// -*- C++ -*- std header                                                      |
//-----------------------------------------------------------------------------+
//                                                                             |
// stat.h                                                                      |
//                                                                             |
// C++ code                                                                    |
//                                                                             |
// Copyright Walter Dehnen, 2000-2001                                          |
// e-mail:   dehnen@mpia.de                                                    |
// address:  Max-Planck Institut fr Astronomie,                               |
//           Knigstuhl 17, D-69117 Heidelberg, Germany                        |
//                                                                             |
//-----------------------------------------------------------------------------+
//                                                                             |
// defines                                                                     |
//                                                                             |
// class TreeStats           fully inline                                      |
//                                                                             |
//-----------------------------------------------------------------------------+

#ifndef included_stat_h
#define included_stat_h

#ifndef included_auxx_h
#include <nbdy/auxx.h>
#endif

////////////////////////////////////////////////////////////////////////////////
// class TreeStats
namespace nbdy {
  class TreeStats {
  private:
    uint N_BB, N_CB, M_CB, N_CC, M_CC, M_CS;
  public:
    // 1 recording
    void reset    () { N_BB=0; N_CB=0; M_CB=0; N_CC=0; M_CC=0; M_CS=0; }
    void record_BB() { N_BB++; }
    void record_taylor_CB() { N_CB++; }
    void record_taylor_CC() { N_CC++; }
    void record_direct_CB() { M_CB++; }
    void record_direct_CC() { M_CC++; }
    void record_direct_CS() { M_CS++; }
    // 2 reporting
    const uint& BB_iacts()        const { return N_BB; }
    const uint& CB_taylor_iacts() const { return N_CB; }
    const uint& CC_taylor_iacts() const { return N_CC; }
    const uint& CB_direct_iacts() const { return M_CB; }
    const uint& CC_direct_iacts() const { return M_CC; }
    const uint& CS_direct_iacts() const { return M_CS; }
  };
}
////////////////////////////////////////////////////////////////////////////////
#endif // included_stat_h
